%{
#include <stdio.h>

// Tablica wartoci zmiennych
int d_value[1000];

// Odszukanie wartoci zmiennej
int dict_value(int key) {
    return d_value[key];
}

// Przypisanie wartoci zmiennej
int dict_set(int key,int value) {
    d_value[key]=value;
}

%}

%token NUM CMD_PRINT CMD_SET ID

%%

input: /* nic */
    | input line 
    ;
    
line: '\n'
    | CMD_SET ID '=' exp '\n' { dict_set($2,$4); }
    | CMD_PRINT exp '\n' { printf("%d\n",$2); }
    ;
    
exp : exp '+' skl  { $$ = $1 + $3 }
    | exp '-' skl  { $$ = $1 - $3 }
    | skl         
    ;

skl : skl '*' czy  { $$ = $1 * $3 }
    | skl '/' czy  { $$ = $1 / $3 }
    | czy         
    ;

czy : NUM          
    | ID           { $$ = dict_value($1); }
    | '(' exp ')'  { $$ = $2 } 
    ;

%%

main()
{
  // Wyzerowanie wartoci zmiennych
  bzero(&d_value,sizeof(d_value));
  
  yyparse();
}

yyerror(s)
char *s;
{
    fprintf(stderr, "%s\n", s);
}
